package cn.wisenergy.mapper;

import cn.hutool.system.UserInfo;
import cn.wisenergy.model.app.User;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * @author 86187
 * @ Description:
 * @ Author     : 86187
 * @ Date       : 2021/1/6 15:32
 */
@Mapper
public interface UsersMapper extends BaseMapper<User> {
    /**
     * 添加
     *
     * @param user 用户信息
     * @return 用户信息
     */
    int add(User user);

    /**
     * 编辑
     *
     * @param user 用户信息
     * @return 修改是否成功
     */
    int edit(User user);

    /**
     * 删除
     *
     * @param id 用户id
     * @return 删除是否成功
     */
    int delById(@Param("id") Integer id);

    /**
     *
     * @param id 用户id
     * @return 用户信息
     */
    User getById(@Param("id") Integer id);

    int countByPhoneAnsUserId(@Param("phone") String phone, @Param("userId") Integer userId);

    List<User> getList(Map<String, Object> map);

    Integer getUserNumbers(Map<String, Object> map);

    User getByPhone(@Param("phone") String phone);

    List<User> test(@Param("list") List<String> list);
}
